#!/usr/bin/perl -w

# Copyright (c) 2001 imacat
# vҦ (c) 2001 ̺
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# {OۥѳnAziHӦۥѳn|] Free Software Foundation
# ^X GNU qΤ@\iұڡ] GNU General Public License ^ĤG
# ӭקMsoGo@{AΪ̦ۥѿܨϥΥsC
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# oGo@{تOƱ楦ΡASOCƦܨSAXSwت
# tOCԲӪpаѾ\ GNU qΤ@\iҡC
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# zӤwgM{@_@ GNU qΤ@\iҪƥCpG٨SAg
# HG Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# ɮצW:	arclog.pl
# ɮ׻:	Perl Oɫkɵ{
# ɮת:	2.0.6
# ɮק@:	̺ <imacat@mail.imacat.idv.tw>
# Z:	2001-01-05
# vr:	(c) 2001 ̺

# Filename:	arclog.pl
# Description:	Perl script to archieve log files monthly
# Version:	2.0.6
# Author:	imacat <imacat@mail.imacat.idv.tw>
# Date:		2001-01-05
# Copyright:	(c) 2001 imacat

use 5.005;
use strict;
use Fcntl qw(:flock);
use IO::File qw();
use IO::Handle qw(autoflush);
use Getopt::Long qw(GetOptions);
use Cwd qw(cwd);
use File::Basename qw(basename fileparse);
use File::Spec::Functions qw(file_name_is_absolute catfile splitdir curdir updir);
use File::Temp qw(tempfile);
use Config qw(%Config);
use Date::Parse qw(str2time);
use Compress::Zlib qw(gzopen);

use vars qw($VERBOSE $COMPRESS $COMPRESS_SUFFIX $TMP_SUFFIX $SORT $SORT_SIZE_LIMIT $THIS_MONTH $DATE_RE %FN);
$VERBOSE = 1;
$COMPRESS = 1;
*COMPRESS_SUFFIX = \".gz";
*TMP_SUFFIX = \".tmp-arclog";
$SORT = 0;
*SORT_SIZE_LIMIT = \50000000;
$THIS_MONTH = to_yyyymm($^T);
%FN = qw();
use vars qw($OVERRIDE $DEFAULT_OVERRIDE_TTY $DEFAULT_OVERRIDE_NOTTY $KEEP $DEFAULT_KEEP);
*DEFAULT_OVERRIDE_TTY = \"ask";
*DEFAULT_OVERRIDE_NOTTY = \"fail";
*DEFAULT_KEEP = \"this-month";

use vars qw($THIS_FILE $SHORTHELP $VERNO $VERSTR $HELPSTR);
$0 =~ /[^\/]*$/;
$THIS_FILE = $&;
$SHORTHELP = "Try `$THIS_FILE --help' for more information.";
*VERNO = \"2.0.6";
$VERSTR = "$& v$VERNO by imacat <imacat\@mail.imacat.idv.tw>";
$HELPSTR = << "EOF";
Usage: $THIS_FILE [options] logfile... [output]
Archieve the log files monthly.

  logfile            The log file to be archieved.
  output             The prefix of the output files. The output files will be
                     named as pre.yyyymm, ie: pre.200001, pre.200002. If not
                     specified, the default prefix is the logfile pathname.
  --compress         Compress the archived files. (default)
  --nocompress       Don't compress the archived files.
  --sort             Sort the records in the log files by time.
  --nosort           Don't sort the records. (default)
  --override[=mode]  The override behavior when the target archived files
                     exist. Available modes are: overwrite, append, ignore,
                     fail and ask. If not specified, the default is "ask" on
                     tty, "fail" for else. If specified without mode, the
                     default is "overwrite".
  --keep[=mode]      What to keep in the logfile. Available modes are: all,
                     restart, delete and this-month. If not specified, the
                     default is "this-month". if specified without mode, the
                     default is "all".
  -d,--debug         Display debugging messages.
  -q,--quiet         Be quiet. Only yell when errors.
  -h,--help          Display this help.
  -v,--version       Display version number.

EOF

main();
exit 0;

# main: Main program D{
sub main {
	local $_;
	my (@source, $output);
	my ($total, $val_counter);
	
	# Parse the arguments ѼƸѪR
	($output, @source) = parse_args();
	
	# Archive each log file @Ӥ@kɾz
	($total, $val_counter) = (0, 0);
	foreach (@source) {
		# Archive a log file z@ӰO
		@_ = arc_log ($_, $output);
		$total += $_[0];
		$val_counter += $_[1];
	}
	
	# Delete the temporary working files RȦs
	foreach (sort keys %FN) {
		print STDERR "Deleting temporary file for $_... " if $VERBOSE >= 2;
		unlink ($FN{$_}) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	}
	
	# Print the statistics ܲέpG
	print STDERR "" . format_number(0+keys %FN) . " archieve files written, " . format_number(time - $^T) . " seconds elapsed.\n" if $VERBOSE >= 1;
	return;
}

# parse_args: Parse the arguments ѼƸѪR
sub parse_args {
	local $_;
	my (@source, $output);
	
	# Get the arguments oѼ
	eval {
		local $SIG{__WARN__} = sub { die $_[0]; };
		Getopt::Long::Configure ("no_auto_abbrev");
		GetOptions(	"compress|c!"=>\$COMPRESS,
				"sort|s!"=>\$SORT,
				"override|o:s"=>\$OVERRIDE,
				"keep|k:s"=>\$KEEP,
				"debug|d"=>sub { $VERBOSE = 2; },
				"quiet|q"=>sub { $VERBOSE = 0; },
				"help|h"=>sub { print $HELPSTR; exit 0; },
				"version|v"=>sub { print "$VERSTR\n"; exit 0; });
	};
	$! = 1;
	die "$THIS_FILE: $@" if $@;
	if (defined $OVERRIDE) {
		$OVERRIDE = "overwrite" if $OVERRIDE eq "";
		$OVERRIDE = lc $OVERRIDE;
		if ($OVERRIDE eq "o") {
			$OVERRIDE = "overwrite";
		} elsif ($OVERRIDE eq "a") {
			$OVERRIDE = "append";
		} elsif ($OVERRIDE eq "i") {
			$OVERRIDE = "ignore";
		} elsif ($OVERRIDE eq "f") {
			$OVERRIDE = "fail";
		}
		if ($OVERRIDE !~ /^(?:overwrite|append|ignore|fail|ask)$/) {
			die "$THIS_FILE: unknown override mode: $OVERRIDE";
		}
	}
	if (defined $KEEP) {
		$KEEP = "all" if $KEEP eq "";
		$KEEP = lc $KEEP;
		if ($KEEP eq "a") {
			$KEEP = "all";
		} elsif ($KEEP eq "r") {
			$KEEP = "restart";
		} elsif ($KEEP eq "d") {
			$KEEP = "delete";
		} elsif ($KEEP eq "t") {
			$KEEP = "this-month";
		}
		if ($KEEP !~ /^(?:all|restart|delete|this-month)$/) {
			die "$THIS_FILE: unknown keep mode: $KEEP";
		}
	}
	
	# Get the rest arguments olѼ
	@source = qw();
	# No arguments SѼ
	if (@ARGV == 0) {
	# Only one argument -- source the same with the output prefix @ӰѼơСпJMX}YۦP
	} elsif (@ARGV == 1) {
		@source = ($ARGV[0]);
		$output = $ARGV[0] if $ARGV[0] ne "-";
		$output =~ s/\.gz$//;
	# Many arguments -- last one is the output prefix ܦhӰѼơСг̫@ӬOX}Y
	} else {
		$output = pop @ARGV;
		@source = @ARGV;
	}
	
	# Set the verbose level ]wT
	autoflush STDOUT if $VERBOSE >= 2;
	
	# Check the log file ˬdO
	$! = 1;
	die "$THIS_FILE: which log file do you want to archive?\n$SHORTHELP\n"
		unless @source > 0;
	die "$THIS_FILE: you can only specify STDIN once\n$SHORTHELP\n"
		if grep ($_ eq "-", @source) > 1;
	foreach (@source) {
		next if $_ eq "-";
		$_ = rel2abs($_);
		die "$THIS_FILE: no such file or directory: $_\n$SHORTHELP\n"
			unless -e $_;
		die "$THIS_FILE: permission denied: $_\n$SHORTHELP\n"
			unless -r $_ && -w $_;
	}
	
	# Can't get the log file and the answer both from STDIN OɩMݵҦPɨӦۼзǿJ
	if (defined $OVERRIDE) {
		if (grep ($_ eq "-", @source) > 0 && $OVERRIDE eq "ask") {
			print STDERR "$THIS_FILE: Can't read from STDIN in ask mode. Change to fail mode.\n";
			$OVERRIDE = "fail";
		}
	}
	
	# Set the default override mode ]ww]\ɼҦ
	if (!defined $OVERRIDE) {
		if (-t STDIN) {
			$OVERRIDE = $DEFAULT_OVERRIDE_TTY;
		} else {
			$OVERRIDE = $DEFAULT_OVERRIDE_NOTTY;
		}
	}
	# Set the default keep mode ]ww]OdҦ
	if (!defined $KEEP) {
		$KEEP = $DEFAULT_KEEP;
	}
	
	# Can't keep the records of this month back in STDIN Os^зǿJ
	if (grep ($_ eq "-", @source) > 0 && $KEEP eq "this-month") {
		print STDERR "$THIS_FILE: Can't keep this-month in STDIN. Change to keep all.\n";
		$KEEP = "all";
	}
	# Can't delete STDIN зǿJLkR
	if (grep ($_ eq "-", @source) > 0 && $KEEP eq "delete") {
		print STDERR "$THIS_FILE: Can't delete the STDIN. Change to keep all.\n";
		$KEEP = "all";
	}
	# Can't restart STDIN зǿJLkks
	if (grep ($_ eq "-", @source) > 0 && $KEEP eq "restart") {
		print STDERR "$THIS_FILE: Can't restart the STDIN. Change to keep all.\n";
		$KEEP = "all";
	}
	
	# Check the output file prefix ˬdXɮ
	$! = 1;
	die "$THIS_FILE: Please specify output prefix\n$SHORTHELP\n"
		unless defined $output;
	die "$THIS_FILE: You can't specify STDOUT as the output prefix\n$SHORTHELP\n"
		if $output eq "-";
	$output = rel2abs ($output);
	$_ = (fileparse $output)[1];
	$! = 1;
	die "$THIS_FILE: no such file or directory: $_\n$SHORTHELP\n"
		unless -e $_;
	die "$THIS_FILE: invalid directory: $_\n$SHORTHELP\n"
		unless -d $_;
	die "$THIS_FILE: permission denied: $_\n$SHORTHELP\n"
		unless -w $_;
	die "$THIS_FILE: temporary file found: $output$TMP_SUFFIX\n$SHORTHELP\n"
		if -e "$output$TMP_SUFFIX";
	
	return ($output, @source);
}

# arc_log: Archive a log file z@ӰO
sub arc_log {
	local $_;
	my ($source, $working, $output);
	my ($total, $val_counter);
	my ($month, $cur_month, $fh);
	my ($entry);
	my (%mon_counter);
	my ($fh0, %fn, $gz, $bytes);
	my ($override);
	($source, $output) = @_;
	
	($total, $val_counter) = (0, 0);
	# Open the log file }ҰO
	(*WORKING_SRC, $total, $working)  = open_src ($source, $output);
	# If the log file is empty OɬOŪ
	if ($total == 0) {
		print STDERR "No records read\n" if $VERBOSE >= 1;
		return (0, 0);
	}
	
	# Check the log file format ˬdOɮ榡
	$entry = <WORKING_SRC>;
	print STDERR "Checking the log file format... " if $VERBOSE >= 2;
	if ($entry =~ /^\S+ \S+ .*? \[(\d{2}\/[A-Z][a-z]{2}\/\d{4}:\d{2}:\d{2}:\d{2} [+\-]\d{4})\]/) {
		$DATE_RE = "^\\S+ \\S+ .*? \\[(\\d{2}\\/[A-Z][a-z]{2}\\/\\d{4}:\\d{2}:\\d{2}:\\d{2} [+\\-]\\d{4})\\]";
		print STDERR "apache\n" if $VERBOSE >= 2;
	} elsif ($entry =~ /^([A-Z][a-z]{2}  ?\d{1,2} \d{2}:\d{2}:\d{2}) /) {
		$DATE_RE = "^([A-Z][a-z]{2}  ?\\d{1,2} \\d{2}:\\d{2}:\\d{2}) ";
		print STDERR "syslog\n" if $VERBOSE >= 2;
	} else {
		print STDERR "unknown\n" if $VERBOSE >= 2;
		$! = 1;
		die "$THIS_FILE: Unrecognized log file format";
	}
	
	# Process the records one by one @@Bz
	undef $cur_month;
	do {
		next unless $entry =~ /$DATE_RE/;
		next unless defined ($_ = str2time $1);
		$month = to_yyyymm($_);
		
		# End the previous month WӤ
		if (defined $cur_month && $month ne $cur_month) {
			# This month -- don't close anything ɡAn
			if (defined $cur_month && $cur_month eq $THIS_MONTH && $KEEP eq "this-month") {
				print STDERR "done\n" if $VERBOSE >= 2;
				print STDERR "" . format_number($mon_counter{$THIS_MONTH}) . " records preserved for $THIS_MONTH\n" if $VERBOSE >= 1;
			
			# Previous file opened -- close it eӤɮפw}ɡA
			} elsif (defined $fh && defined fileno $fh) {
				flock ($fh, LOCK_UN) || die "$THIS_FILE: $!";
				close ($fh) || die "$THIS_FILE: $!";
				print STDERR "done\n" if $VERBOSE >= 2;
				print STDERR "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
			
			# Ignored months -- report only A^έp
			} elsif (exists $fn{$cur_month} && !defined $fn{$cur_month}) {
				print STDERR "done\n" if $VERBOSE >= 2;
				print STDERR "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
			}
		}
		
		# Start a new month }lU@Ӥ
		if (!defined $cur_month || $month ne $cur_month) {
			# This month -- open a temporary working file ж}Ȧs
			if ($month eq $THIS_MONTH && $KEEP eq "this-month") {
				if (!defined $fh0) {
					($fh0 = tempfile) || die "$THIS_FILE: $!";
					flock ($fh0, LOCK_EX) || die "$THIS_FILE: $!";
				}
				print STDERR "Preserving records of $month... " if $VERBOSE >= 2;
			
			# Other months -- open file oж}
			} else {
				# Inherit the previous temporary working file ~ӤeȮɤu@
				$fn{$month} = $FN{$month} if !exists $fn{$month} && exists $FN{$month};
				# First time -- open a new file Ĥ@ж}s
				if (!exists $fn{$month}) {
					$fn{$month} = "$output.$month";
					$fn{$month} .= $COMPRESS_SUFFIX if $COMPRESS;
					
					# Target file exists ɮפwsb
					if (-e $fn{$month}) {
						$override = $OVERRIDE;
						# If we should ask pGn@@߰ݪ
						while ($override eq "ask") {
							print STDERR "$fn{$month} already exists, (O)verwrite, (A)ppend, (I)gnore, (F)ail? [F] ";
							$_ = <STDIN>;
							# Fail if not answered SnAN
							if (!defined $_) {
								print STDERR "\nArhh.. you are not here. I'd better drop it right now.\n";
								$override = "fail";
								last;
							}
							chomp;
							# Overwrite \
							if (lc $_ eq "o" || lc $_ eq "overwrite") {
								$override = "overwrite";
							# Append [Wh
							} elsif (lc $_ eq "a" || lc $_ eq "append") {
								$override = "append";
							# Ignore 
							} elsif (lc $_ eq "i" || lc $_ eq "ignore") {
								$override = "ignore";
							# Fail 
							} elsif (lc $_ eq "f" || lc $_ eq "fail" || lc $_ eq "") {
								$override = "fail";
							# Else, ask again _hA
							} else {
								print STDERR "What?\n";
								$override = "ask";
							}
						}
						# Overwrite, do nothing \Aޥ
						if ($override eq "overwrite") {
						
						# Append, handle when opening file [WhA}ɮɦABz
						} elsif ($override eq "append") {
						
						# Ignore, undefine the filename A]ɦW
						} elsif ($override eq "ignore") {
							undef $fn{$month};
						
						# Else, stop processing A{
						} else {
							foreach (keys %mon_counter) {
								unlink ($fn{$_}) || die "$THIS_FILE: $!";
							}
							die "$THIS_FILE: File exists $fn{$month}";
						}
					}
					
					# Ignore, open nothing An}
					if (!defined $fn{$month}) {
						print STDERR "Ignoring records of $month... " if $VERBOSE >= 2;
					
					# Append, output the original to temporary working files sWAlO]giȦsɤ
					} elsif (-e $fn{$month} && $override eq "append") {
						print STDERR "Reading original records of $month... " if $VERBOSE >= 2;
						if ($COMPRESS) {
							open (ORIGINAL, $fn{$month}) || die "$THIS_FILE: $!";
							flock (ORIGINAL, LOCK_SH) || die "$THIS_FILE: $!";
							$gz = gzopen(*ORIGINAL, "rb") || die "$THIS_FILE: $!";
							(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
							$FN{$month} = $fn{$month};
							flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
							while (($bytes = $gz->gzreadline($_)) != 0) {
								die "$THIS_FILE: " . $gz->gzerror() if $bytes == -1;
								(print $fh $_) || die "$THIS_FILE: $!";
							}
							flock (ORIGINAL, LOCK_UN) || die "$THIS_FILE: $!";
							close (ORIGINAL) || die "$THIS_FILE: $!";
							undef $gz;
						} else {
							open (ORIGINAL, $fn{$month}) || die "$THIS_FILE: $!";
							flock (ORIGINAL, LOCK_SH) || die "$THIS_FILE: $!";
							(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
							$FN{$month} = $fn{$month};
							flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
							print $fh $_ while <ORIGINAL>;
						}
						print STDERR "done\n" if $VERBOSE >= 2;
						print STDERR "Appending records of $month... " if $VERBOSE >= 2;
					
					# Open a temporary working file }Ȧs
					} else {
						print STDERR "Archiving records of $month... " if $VERBOSE >= 2;
						(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
						$FN{$month} = $fn{$month};
						flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
					}
				
				# Opened before, append it }LաХ[̫᭱
				} else {
					# Ignore, open nothing An}
					if (!defined $fn{$month}) {
						print STDERR "Ignoring records of $month... " if $VERBOSE >= 2;
					
					# Else, append _hA[̫᭱
					} else {
						print STDERR "Archiving records of $month... " if $VERBOSE >= 2;
						($fh = new IO::File ">>$fn{$month}") || die "$THIS_FILE: $!";
						flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
					}
				}
			}
			$cur_month = $month;
		}
		
		# Save it sih
		# This month, save to $fh0 As $fh0
		if ($month eq $THIS_MONTH && $KEEP eq "this-month") {
			(print $fh0 $entry) || die "$THIS_FILE: $!";
		
		# Ignore, save nothing Ans
		} elsif (!defined $fn{$month}) {
		
		# Other months, save to $fh oAs $fh
		} else {
			(print $fh $entry) || die "$THIS_FILE: $!";
		}
		
		# Add the counter έp
		$mon_counter{$month} = 0 if !exists $mon_counter{$month};
		$mon_counter{$month}++;
		$val_counter++;
	} while defined ($entry = <WORKING_SRC>);
	
	# Deal the archived records BzkɪO
	# Previous is this month -- report only eӤOɡAɡAiέp
	if ($cur_month eq $THIS_MONTH && $KEEP eq "this-month") {
		print STDERR "done\n" if $VERBOSE >= 2;
		print STDERR "" . format_number($mon_counter{$THIS_MONTH}) . " records preserved for $THIS_MONTH\n" if $VERBOSE >= 1;
	
	# Previous file opened -- close it oɮפw}ɡA
	} elsif (defined $fh && defined fileno $fh) {
		flock ($fh, LOCK_UN) || die "$THIS_FILE: $!";
		close ($fh) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		print STDERR "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
	
	# Ignored months -- report only A^έp
	} elsif (!defined $fn{$cur_month}) {
		print STDERR "done\n" if $VERBOSE >= 2;
		print STDERR "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
	}
	
	# Delete the filenames of ignored months RɦW
	foreach (keys %fn) {
		delete $fn{$_} unless defined $fn{$_};
	}
	
	# Sort the archives by date/time ɶƧ
	sort_arcs (%fn) if $SORT;
	
	# Save the archives Nkɫ᪺Os
	save_arcs ($output, %fn);
	
	# Keep the records of this month OdoӤ몺O
	if ($KEEP eq "this-month" && defined $fh0 && defined fileno $fh0) {
		print STDERR "Returning records of $THIS_MONTH... " if $VERBOSE >= 2;
		open (SOURCE, "+<$source") || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_EX) || die "$THIS_FILE: $!";
		print $fh0 $_ while $_ = <SOURCE>;
		seek (SOURCE, 0, 0) || die "$THIS_FILE: $!";
		truncate (SOURCE, 0) || die "$THIS_FILE: $!";
		seek ($fh0, 0, 0) || die "$THIS_FILE: $!";
		print SOURCE while <$fh0>;
		flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
		close (SOURCE) || die "$THIS_FILE: $!";
		flock ($fh0, LOCK_UN) || die "$THIS_FILE: $!";
		close ($fh0) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		delete $mon_counter{$THIS_MONTH};
	}
	
	# Delete the temporary working file RȮɤu@
	if (defined $working) {
		print STDERR "Deleting $working... " if $VERBOSE >= 2;
		seek (WORKING_SRC, 0, 0) || die "$THIS_FILE: $!";
		truncate (WORKING_SRC, 0) || die "$THIS_FILE: $!";
		flock (WORKING_SRC, LOCK_UN) || die "$THIS_FILE: $!";
		close (WORKING_SRC) || die "$THIS_FILE: $!";
		unlink ($working) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	}
	
	return ($total, $val_counter);
}

# open_src: Open the log file }ҰO
sub open_src {
	local $_;
	my ($source, $output, $working, $target, $total, $gz, $bytes);
	($source, $output) = @_;
	
	$total = 0;
	# Read the log file from STDIN ѼзǿJŪO
	if ($source eq "-") {
		# Open the temporary working file }ҼȮɤu@
		$target = "temporary working file";
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		*WORKING_SRC = *STDIN;
		(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from STDIN to $target... " if $VERBOSE >= 2;
		while ($_ = <STDIN>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
	
	# Gzopen the gzipped file } GZIP ɮ
	} elsif ($source =~ /\.gz$/) {
		# Open the temporary working file }ҼȮɤu@
		if ($KEEP eq "all") {
			$target = "temporary working file";
			print STDERR "Creating $target... " if $VERBOSE >= 2;
			*WORKING_SRC = *STDIN;
			(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		
		} else {
			$working = $output;
			$working =~ s/\.gz$//;
			$working .= $TMP_SUFFIX;
			$target = $working;
			print STDERR "Creating $target... " if $VERBOSE >= 2;
			open (WORKING_SRC, "+>$working") || die "$THIS_FILE: $!";
			flock (WORKING_SRC, LOCK_EX) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		open (SOURCE, "+<$source") || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_EX) || die "$THIS_FILE: $!";
		$gz = gzopen(*SOURCE, "rb") || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while (($bytes = $gz->gzreadline($_)) != 0) {
			die "$THIS_FILE: " . $gz->gzerror() if $bytes == -1;
			(print WORKING_SRC $_) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		if ($KEEP ne "delete") {
			# Close the source O
			print STDERR "Closing $source... " if $VERBOSE >= 2;
			flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
			close (SOURCE) || die "$THIS_FILE: $!";
			undef $gz;
			print STDERR "done\n" if $VERBOSE >= 2;
		} else {
			# Close the source O
			print STDERR "Closing $source... " if $VERBOSE >= 2;
			seek (SOURCE, 0, 0) || die "$THIS_FILE: $!";
			truncate (SOURCE, 0) || die "$THIS_FILE: $!";
			flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
			close (SOURCE) || die "$THIS_FILE: $!";
			undef $gz;
			print STDERR "done\n" if $VERBOSE >= 2;
			
			# Delete the source RO
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
	
	# Empty file -- bounce directly ɡСЪ
	} elsif (-z $source) {
		print STDERR "No records read from $source\n" if $VERBOSE >= 1;
		# Delete the source RO
		if ($KEEP eq "delete") {
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
		return (*STDIN, 0);
	
	# Ordinary file @ɮ
	# Keep all, copy to temporary file OdOɡAƻsȮɤu@
	} elsif ($KEEP eq "all") {
		# Open the temporary working file }ҼȮɤu@
		$target = "temporary working file";
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		*WORKING_SRC = *STDIN;
		(WORKING_SRC = tempfile) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		open (SOURCE, $source) || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_SH) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while ($_ = <SOURCE>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Close the source O
		print STDERR "Closing $source... " if $VERBOSE >= 2;
		flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
		close (SOURCE) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
	
	# Else, copy to temporary file and restart _hAƻsȮɤu@ɨçOks
	} else {
		# Open the temporary working file }ҼȮɤu@
		$working = $output . $TMP_SUFFIX;
		$target = $working;
		print STDERR "Creating $target... " if $VERBOSE >= 2;
		open (WORKING_SRC, "+>$working") || die "$THIS_FILE: $!";
		flock (WORKING_SRC, LOCK_EX) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Open the source }ҭO
		print STDERR "Opening $source... " if $VERBOSE >= 2;
		open (SOURCE, "+<$source") || die "$THIS_FILE: $!";
		flock (SOURCE, LOCK_EX) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Copy to the temporary working file ƻsȮɤu@
		print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
		while ($_ = <SOURCE>) {
			(print WORKING_SRC) || die "$THIS_FILE: $!";
			$total++;
		}
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Restart the source Oks
		print STDERR "Restarting $source... " if $VERBOSE >= 2;
		seek (SOURCE, 0, 0) || die "$THIS_FILE: $!";
		truncate (SOURCE, 0) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Close the source O
		print STDERR "Closing $source... " if $VERBOSE >= 2;
		flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
		close (SOURCE) || die "$THIS_FILE: $!";
		print STDERR "done\n" if $VERBOSE >= 2;
		
		# Delete the source RO
		if ($KEEP eq "delete") {
			print STDERR "Deleting $source... " if $VERBOSE >= 2;
			unlink ($source) || die "$THIS_FILE: $!";
			print STDERR "done\n" if $VERBOSE >= 2;
		}
	}
	
	# Return the file reader ŪgYk
	seek (WORKING_SRC, 0, 0) || die "$THIS_FILE: $!";
	
	print STDERR "" . format_number($total) . " entries found in " . ($source eq "-"? "STDIN": $source) . "\n"  if $VERBOSE >= 1;
	
	return (*WORKING_SRC, $total, $working);
}

# sort_arcs: Sort the archives by date/time ɶƧ
sub sort_arcs {
	local $_;
	my ($month, %fn, %order, $date, $cur_date, $num_format);
	%fn = @_;
	
	$num_format = "%0" . (int ((log $SORT_SIZE_LIMIT) / (log 10)) + 1) . "d";
	
	# Sort each file CɮױƧ
	foreach $month (sort keys %fn) {
		print "Sorting records of $month... " if $VERBOSE >= 2;
		# Abort if over the limit WLjpWN
		if (-s $fn{$month} > $SORT_SIZE_LIMIT) {
			print "failed.\n" if $VERBOSE >= 2;
			print STDERR "$THIS_FILE: Too many records. Abort.\n";
			next;
		
		# Sort directly if less than 50MB  50MB Ƨ
		} else {
			open (DATA, "+<$fn{$month}") || die "$THIS_FILE: $!";
			flock (DATA, LOCK_EX) || die "$THIS_FILE: $!";
			@_ = <DATA>;
			%order = qw();
			for ($_ = 0; $_ < @_; $_++) {
				$_[$_] =~ /$DATE_RE/;
				$order{str2time($1) . " " . sprintf($num_format, $_)} = $_;
			}
			seek (DATA, 0, 0) || die "$THIS_FILE: $!";
			truncate (DATA, 0) || die "$THIS_FILE: $!";
			foreach (sort keys %order) {
				if (!defined $_[$order{$_}]) {
					print "$month: \"$_\" \"$order{$_}\" \"$_[$order{$_}]\"\n";
					<STDIN>;
				}
				(print DATA $_[$order{$_}]) || die "$THIS_FILE: $!";
			}
			flock (DATA, LOCK_UN) || die "$THIS_FILE: $!";
			close (DATA) || die "$THIS_FILE: $!";
		}
		print "done\n" if $VERBOSE >= 2;
	}
	return;
}

# save_arcs: Save the archives Nkɫ᪺Os
sub save_arcs {
	local $_;
	my ($output, $month, $path, $file, $gz, $size_src, $size_comp, $ratio, %tmpfn);
	($output, %tmpfn) = @_;
	
	# Save each file from the temporary working files qȦsɤs
	foreach $month (sort keys %tmpfn) {
		# Obtain the filename oɦW
		$path = "$output.$month";
		$path .= $COMPRESS_SUFFIX if $COMPRESS;
		$file = basename($path);
		$size_src = -s $tmpfn{$month};
		
		# Save s
		print "Saving records of $month to $path... " if $VERBOSE >= 2;
		# Open the temporary working file }ҼȦs
		open (TEMP, $tmpfn{$month}) || die "$THIS_FILE: $!";
		flock (TEMP, LOCK_SH) || die "$THIS_FILE: $!";
		if ($COMPRESS) {
			# Write to a compressed file gYɤ
			$gz = gzopen($path, "wb9") || die "$THIS_FILE: $!";
			while (defined ($_ = <TEMP>)) {
				$gz->gzwrite($_) || die "$THIS_FILE: " . $gz->gzerror();
			}
			$gz->gzclose() && die "$THIS_FILE: " . $gz->gzerror();
		} else {
			# Write to an ordinary file g@ɤ
			open (RESULT, ">$path") || die "$THIS_FILE: $!";
			flock (RESULT, LOCK_EX) || die "$THIS_FILE: $!";
			print RESULT while <TEMP>;
			flock (RESULT, LOCK_UN) || die "$THIS_FILE: $!";
			close (RESULT) || die "$THIS_FILE: $!";
		}
		# Close the temporary working file Ȧs
		flock (TEMP, LOCK_UN) || die "$THIS_FILE: $!";
		close (TEMP) || die "$THIS_FILE: $!";
		print "done\n" if $VERBOSE >= 2;
		
		# Report the statistics ^έpƦr
		if ($COMPRESS) {
			$size_comp = -s $path;
			$ratio = sprintf "%4.2f", ($size_comp/$size_src)*100;
			$size_src = format_number($size_src);
			$size_comp = format_number($size_comp);
			print "$file compressed from $size_src bytes to $size_comp bytes, ratio $ratio%\n" if $VERBOSE >= 1;
		}
	}
	return;
}

# to_yyyymm: convert timestamp to yyyymm Nɶର yyyymm 榡
sub to_yyyymm {
	local $_;
	@_ = localtime $_[0];
	return sprintf "%04d%02d", $_[5] + 1900, $_[4] + 1;
}

# format_number: Format the number every 3 digit ƦrCTƥ[@J
sub format_number {
	local $_;
	$_ = $_[0];
	# Group every 3 digit CTƥ[@J
	$_ = $1 . "," . $2 . $3 while /^([^\.]*\d)(\d\d\d)(.*)$/;
	return $_;
}

# rel2abs: Convert a relative path to an absolute path ۹|ର|
sub rel2abs {
	local $_;
	my ($user, $path, $base);
	($path, $base) = @_;
	
	# Turn the base absolute Ҭ۹諸|ন|
	$base = cwd unless defined $base;
	$base = rel2abs ($base) if !file_name_is_absolute $base;
	
	# Deal the ~ home directories under UNIX b UNIX UBz ~ ϥΪ̪ڥؿ
	if (defined $Config{"d_getpwent"}) {
		@_ = splitdir ($path);
		# If start from user's home directory YOqϥΪ̮ڥؿ}l
		if ($_[0] =~ /^~(.*)$/) {
			$user = $1;
			# Get the current user if user not specified YϥΪ̨S]wAHثeϥΪ̬
			$user = getlogin if $user eq "";
			# Get the user home directory oϥΪ̮ڥؿ
			$_ = (getpwnam $user)[7];
			# Replace with the user home directory NϥΪ̮ڥؿ
			$_[0] = $_ if defined $_;
			# Compose the path զX|
			$path = catfile @_;
		}
	}
	
	# Append the current directory if relative ۹|Wثe|
	$path = catfile ($base, $path) unless file_name_is_absolute $path;
	
	@_ = splitdir ($path);			# Split into directory components Uhؿ
	# Add an empty filename level if last level is a directory ̫@hOؿɡA[WťɦWh
	push @_, "" if ($_[@_-1] eq curdir || $_[@_-1] eq updir);
	for ($_ = 1; $_ < @_; $_++) {		# Parse each level one by one @h@hR
		# If it is this directory oӥؿ
		if ($_[$_] eq curdir) {
			splice (@_, $_, 1);	# Remove this level directly ho@h
			$_--;			# The level number drop by 1 hƴ@
		# If it is the parent directory W@hؿ
		} elsif ($_ > 1 && $_[$_] eq updir && $_[$_-1] ne updir) {
			splice (@_, $_-1, 2);	# Remove this and the previous level ho@hMW@h
			$_ -= 2;		# The level number drop by 2 hƴG
		}
	}
	$path = catfile (@_);			# Compose the full path զX|
	return $path;
}

__END__

=head1 NAME

arclog.pl - Archive log files monthly

=head1 SYNOPSIS

 arclog.pl [options] logfile... [output]
 arclog.pl [-h|-v]

=head1 DESCRIPTION

arclog.pl archives the log files monthly. It strips off the log
entries that belongs to the previous months, and save them to the
archived files named F<logfile.yyyymm>. The archive files will be
compressed. The entries of the current month will be kept in the
source. It then saves disk spaces and prevents potentially attacks
on log files.

Current, only the F<apache> access log and L<syslog(2)|syslog/2>
formats are recognized.

Notice: Archiving takes time. From version 2.0.0, it will copy the
source log file to a temporary working file and restart it first. Then
it could take its time working on that temporary working file. This
can maximum reduce the time occupying the source log file, avoiding
the need of foreign log file restarting program. However, please note:
(1) If you have a huge log file (several tenths of MBs), it still
sucks copying. You had better stop logging first, archive the log file
and restart logging, to avoid racing condition writing. If you archive
the log file periodly, it shall not grow too big. (2) If it breaks in
the half of execution, it will leave a temporary working file. The
next time it runs, it will stop seeing that temporary working file at
the first sight. You have to dispose that file first in order to keep
working. You can change it to a different filename and archive it like
an ordinary log file, to solve this.

You could optionally sort the records in the archived files by time
(and then by record order), to solve some problems on merged log
files. But I<BE CAUTIONED>: C<Sorting> eats huge memory and CPU. If
you work on large log files, it might kill the whole system in one
minute. I had made some simple steps to avoid that, but I<I CAN'T
GUARANTEE THAT IT WORKS>. Whether it kills depends on which CPU you
have, how much memory you have and how large your archived file is.
Because of this, by default sorting is turned off.

Be careful on the L<syslog(2)|syslog/2> log files:
L<syslog(2)|syslog/2> does not record the year. F<arclog.pl> uses
L<Date::Parse(3)|Date::Parse/3> to parse the date, which will smartly
judge the year in the range between this month and last next month.
For ex., if today is 2001-06-08, it will put the year between
2001-06-30 back to 2000-07-01 if the year is missing. I think this is
smart enough. However, if you do have a L<syslog(2)|syslog/2> log file
that has records older than that, don't use F<arclog.pl>. It will
destroy your log file.

From version 1.5.0 you can specify "-" to read from C<STDIN>. But
notice here: (1) You I<MUST> specify the output prefix if you want to
read from C<STDIN>, because what it needs is a I<path prefix>, not a
specified file. (2) If you read from a file, the records of this month
will be returned to that file, to be archived next month; but if you
read from C<STDIN>, there's no place to return, so the records of this
month will be archived, too. (3) The answers of the C<ask> mode is
obtained from C<STDIN>, too. Because you have only one C<STDIN>, you
cannot specify the C<ask> mode while reading from C<STDIN>. It will
fall back to the C<fail> mode.

=head1 OPTIONS

=over

=item logfile

The log file to be archived. Specify C<-> to read from C<STDIN>.
Multiple log files are supported.

=item output

The prefix of the output files. The output files will be named as
F<output.yyyymm>, ie: F<output.200101>, F<output.200102>. If not
specified, the default is the same as the log file. You must specify
this if you want to read from C<STDIN>. You cannot specify C<->
(C<STDIN>), because this is only a prefix, not the filename.

=item -c,--compress

Compress the archived files. This is the default. Log files often have
simular lines all over. Compress them saves you lots of disk spaces.
(And this is why we want to I<archive> the log files.) Currently only
the L<gzip(1)|gzip/1> compressing method is supported.

=item --nocompress

Don't compress the archived files. (Are you sure? :p )

=item -s,--sort

Sort the records by time (and then the record order). C<Sorting> eats
huge memory and C<CPU>, so the default is disabled. See the
illustration above for a detailed description on this.

=item --nosort

Don't sort the records. This is the default.

=item -o,--override[=mode]

Whether we should overwrite the existing archived files. Currently
the following modes are supported:

=over

=item o,overwrite

Overwrite any existing target file. If C<--override> was specified
without C<mode>, it assumes that you want to overwrite. You will lost
these existing log records. Use with care. This is only helpful if you
are sure the master log file has the most complete records.

=item a,append

Append the records to the existing target files. You might destroy the
log file completely by putting irrelevant entries altogether
accidently. Use with care. This is only helpful if you append want to
merge 2 log files, for ex., 2 log files in the same kind with
exclusive date ranges.

=item i,ignore

Ignore any existing target file, and discard all the records of those
months. You will lost these log records. Use with care. This is only
helpful if you are supplying log records for the missing months, or if
you are merging the log records in a complex manner.

=item f,fail

Stop processing whenever a target file exists, to prevent destroying
any existing files by accident. This should be mostly wanted when run
from some automatic mechanism, like L<crontab(1)|crontab/1>. So, this
is the default if C<STDIN> is not connected to the terminal.

=item ask

Ask you what to do when a target file exists. This should be most
wanted if you are running this interactively. So, this is the default
if C<STDIN> is connected to the terminal. The answers are read from
C<STDIN>. Because you have only one C<STDIN>, you cannot specify this
mode if you want read the log file from C<STDIN>. It will fall back to
the C<fail> mode. Also, if the program cannot get its answer from
C<STDIN>, for ex., on a closed C<STDIN> like L<crontab(1)|crontab/1>,
it will fall back to the C<fail> mode.

=back

=item -k,--keep[=mode]

What to keep in the original file. Current available modes are:

=over

=item a,all

Keep the source file after records are archived. If C<--keep> was
specified without C<mode>, it assumes that you want to keep all.

=item r,restart

Restart the source file after records are archived.

=item d,delete

Delete the source file after records are archived.

=item t,this-month

Archive and strip records of previous months from the log file. Keep
the records of this month in the source file, to be archived next
month. This is designed to be run from L<crontab(1)|crontab/1>
monthly. So this is the default.

=back

=item -d, --debug

Show the detailed debugging messages.

=item -q, --quiet

Shihhhhhh. Only yell when errors.

=item -h, --help

Display the help message and exit.

=item -v, --version

Output version information and exit.

=back

=head1 VERSION

2.0.6

=head1 COPYRIGHT

Copyright (c) 2001 imacat. All rights reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but I<WITHOUT ANY WARRANTY>; without even the implied warranty of
I<MERCHANTABILITY> or I<FITNESS FOR A PARTICULAR PURPOSE>.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

=head1 AUTHOR

imacat <imacat@mail.imacat.idv.tw>

=head1 BUGS

Please report if any. ^_*'

=head1 TODO

=over

=item Set the sort size limit dynamically

Set the sort size limit according to the actual system memory. This
could be possible only if I can obtain the total amount of the actual
system memory. :p

=item Read from STDIN in a more natural way

For example, C<cat access_log | arclog.pl /archive/access_log>. This
needs a rather complix manuplation on STDIN, since it's a little hard
to judge rather STDIN is detached from terminal due to automatic
mechanism like crontab, or due to named pipe.

=back

=head1 SEE ALSO

L<gzip(1)|gzip/1>, L<zlib(3)|zlib/3>, L<syslog(2)|syslog/2>

=cut
